
<!DOCTYPE html>
<html lang="en">
<head>
    <link rel="stylesheet" type="text/css" href="styles.css">
    <meta charset="UTF-8">
    <title>Pictorial REST API</title>
</head>
<body>

<header>
    <h2> Pictorial review site </h2>
</header>



<div class="sidenav">

    <h1 id="getimage">GET IMAGE BY NAME</h1>
    <form>
        <input id="getImageName" type="text" placeholder="Image name" name="name">
        <input type="submit" value="Get Image" name="submit" onClick="showImage()">
        <br></form>

    <h1 id="likeimage">LIKE IMAGE</h1>
    
    <form
            action="/api/like"
            method="post">
        <input type="text" placeholder="Image name" name="name">
        <input type="submit" value="LIKE" name="submit">
        <br></form>

    <h1 id="dislikeimage">DISLIKE IMAGE</h1>
    <form
            action="/api/dislike"
            method="post">
        <input type="text" placeholder="Image name" name="name">
        <input type="submit" value="DISLIKE" name="submit">
        <br></form>

    <h1 id="deleteimage">DELETE IMAGE BY NAME</h1>
    <form>
        <input id="deleteImageName" type="text" placeholder="Image name" name="name">
        <input type="submit" value="DELETE" name="submit" onclick="deleteImage()">
        <br></form>
</div>

<div class='page'>

    <div class="Upload">
    <h1>SEND IMAGE</h1>
    <form id = "uploadForm"
            action="/api/image"
            method="post"
            enctype="multipart/form-data">
        <input type="text" placeholder="Name" name="name">
        <input type="text" placeholder="Description" name="description">
        <input type="text" placeholder="#tags" name="tags"/>
        <input type="file" name="photo" />
        <input type="submit" value="Upload Image" name="submit"><br>
    </form>
    </div>

    
    <div class="Upload">
        <h1>UPDATE IMAGE INFO</h1>
        <form id = "updateForm"
            action="/api/updateImage"
            method="post">

            <input type="text" placeholder="Name" name="name">
            <input type="text" placeholder="New description" name="description">
            <input type="text" placeholder="New #tags" name="tags"/>
            <input type="submit" value="Update Info" name="submit"><br>
        </form>
        </div>
    


</div>
<div class='page'>
<div id="getallimages">
    <h1>GET ALL IMAGES</h1>
    <input type="submit" value="Get Images" name="submit" onClick="showAllImages()"><br>
</div>
<div id="images">
</div>
</div>
</body>
</html>
<script charset="utf-8">

    // Kuvan lähettäminen AJAXilla
    function postImage(){
        var elements = document.getElementsByClassName("uploadForm");
        var formData = new FormData();
        var xmlhttp = new XMLHttpRequest();

        for(var i=0; i<elements.length; i++)
    {
        formData.append(elements[i].name, elements[i].value);
    }
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                   var json = JSON.parse(xmlhttp.responseText);
                }
            };
            xmlhttp.open("POST", "http://localhost:8081/api/image", true);
            console.log(formData);
            xmlhttp.send(formData);
            console.log(formData);
    }

    //Yhden kuvan noutaminen AJAXilla. API kutsu: /api/image
    function showImage(){
        var name = document.getElementById("getImageName").value
        var xmlhttp = new XMLHttpRequest();
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                    var json = JSON.parse(xmlhttp.responseText);
                    console.log(json)
                    var innerhtml = "";
            
                        innerhtml += '<h1>'+json.pictures[0].name+'</h1><br>';
                        innerhtml += '<img src="public/images/'+json.pictures[0].filepath + '"> <br>';
                        innerhtml += '<p>'+json.pictures[0].description+' <br>' ;
                        innerhtml += 'tags: ' + json.pictures[0].tags+' <br>' ;
                        innerhtml += 'likes: ' + json.pictures[0].likes+'</p> <br>' ;
             
                        console.log(json.pictures[0].filepath);
        
                    document.getElementById("images").innerHTML = innerhtml;


                }
            };
            xmlhttp.open("GET", "http://localhost:8081/api/image/" + name, true);
            xmlhttp.send();
    }

    //Kaikkien kuvien noutaminen AJAXilla. API kutsu: /api/image
    function showAllImages() {
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                    json = JSON.parse(xmlhttp.responseText);
                    var innerhtml = "";
                
                    for (var i = 0, len = json.pictures.length; i < len; i++) {
                        innerhtml += '<h1>'+json.pictures[i].name+'</h1><br>';
                        innerhtml += '<img src="public/images/'+json.pictures[i].filepath + '"> <br>';
                        innerhtml += '<p>'+json.pictures[i].description+' <br>' ;
                        innerhtml += 'tags: ' + json.pictures[i].tags+' <br>' ;
                        innerhtml += 'likes: ' + json.pictures[i].likes+'</p> <br>' ;
                        innerhtml += '<form action="/api/dislike/'+json.pictures[i].id+'" method="post">' +
                                '<input type="submit" value="DISLIKE" name="submit">'+
                                '</form>';
                        innerhtml += '<form action="/api/like/'+json.pictures[i].id+'" method="post">' +
                                '<input type="submit" value="LIKE" name="submit">'+
                                '<br></form>';
             
                        console.log(json.pictures[1].filepath);
                    }
                    document.getElementById("images").innerHTML = innerhtml;


                }
            };
            xmlhttp.open("GET", "http://localhost:8081/api/all_images", true);
            xmlhttp.send();
    }
    
    // Kuvan poistaminen AJAXilla
    function deleteImage(){
        var name = document.getElementById("deleteImageName").value
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.open("DELETE", "http://localhost:8081/api/deleteImage/" + name, true);
        xmlhttp.send();
    }
    
</script>
